// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from marti_sensor_msgs:msg/DioRealTimeData.idl
// generated code does not contain a copyright notice

#ifndef MARTI_SENSOR_MSGS__MSG__DETAIL__DIO_REAL_TIME_DATA__TRAITS_HPP_
#define MARTI_SENSOR_MSGS__MSG__DETAIL__DIO_REAL_TIME_DATA__TRAITS_HPP_

#include "marti_sensor_msgs/msg/detail/dio_real_time_data__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const marti_sensor_msgs::msg::DioRealTimeData & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: sample_frequency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sample_frequency: ";
    value_to_yaml(msg.sample_frequency, out);
    out << "\n";
  }

  // member: latest_sample_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "latest_sample_time: ";
    value_to_yaml(msg.latest_sample_time, out);
    out << "\n";
  }

  // member: sample_states
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.sample_states.size() == 0) {
      out << "sample_states: []\n";
    } else {
      out << "sample_states:\n";
      for (auto item : msg.sample_states) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: sample_times
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.sample_times.size() == 0) {
      out << "sample_times: []\n";
    } else {
      out << "sample_times:\n";
      for (auto item : msg.sample_times) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const marti_sensor_msgs::msg::DioRealTimeData & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<marti_sensor_msgs::msg::DioRealTimeData>()
{
  return "marti_sensor_msgs::msg::DioRealTimeData";
}

template<>
inline const char * name<marti_sensor_msgs::msg::DioRealTimeData>()
{
  return "marti_sensor_msgs/msg/DioRealTimeData";
}

template<>
struct has_fixed_size<marti_sensor_msgs::msg::DioRealTimeData>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<marti_sensor_msgs::msg::DioRealTimeData>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<marti_sensor_msgs::msg::DioRealTimeData>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MARTI_SENSOR_MSGS__MSG__DETAIL__DIO_REAL_TIME_DATA__TRAITS_HPP_
