// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from marti_sensor_msgs:msg/DifferentialMeasurement.idl
// generated code does not contain a copyright notice

#ifndef MARTI_SENSOR_MSGS__MSG__DETAIL__DIFFERENTIAL_MEASUREMENT__TRAITS_HPP_
#define MARTI_SENSOR_MSGS__MSG__DETAIL__DIFFERENTIAL_MEASUREMENT__TRAITS_HPP_

#include "marti_sensor_msgs/msg/detail/differential_measurement__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'position'
#include "geometry_msgs/msg/detail/vector3__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const marti_sensor_msgs::msg::DifferentialMeasurement & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: base_frame_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "base_frame_id: ";
    value_to_yaml(msg.base_frame_id, out);
    out << "\n";
  }

  // member: baseline_length
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "baseline_length: ";
    value_to_yaml(msg.baseline_length, out);
    out << "\n";
  }

  // member: baseline_length_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "baseline_length_variance: ";
    value_to_yaml(msg.baseline_length_variance, out);
    out << "\n";
  }

  // member: heading
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading: ";
    value_to_yaml(msg.heading, out);
    out << "\n";
  }

  // member: heading_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading_variance: ";
    value_to_yaml(msg.heading_variance, out);
    out << "\n";
  }

  // member: pitch
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pitch: ";
    value_to_yaml(msg.pitch, out);
    out << "\n";
  }

  // member: pitch_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pitch_variance: ";
    value_to_yaml(msg.pitch_variance, out);
    out << "\n";
  }

  // member: roll
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roll: ";
    value_to_yaml(msg.roll, out);
    out << "\n";
  }

  // member: roll_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roll_variance: ";
    value_to_yaml(msg.roll_variance, out);
    out << "\n";
  }

  // member: position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position:\n";
    to_yaml(msg.position, out, indentation + 2);
  }

  // member: position_covariance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.position_covariance.size() == 0) {
      out << "position_covariance: []\n";
    } else {
      out << "position_covariance:\n";
      for (auto item : msg.position_covariance) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const marti_sensor_msgs::msg::DifferentialMeasurement & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<marti_sensor_msgs::msg::DifferentialMeasurement>()
{
  return "marti_sensor_msgs::msg::DifferentialMeasurement";
}

template<>
inline const char * name<marti_sensor_msgs::msg::DifferentialMeasurement>()
{
  return "marti_sensor_msgs/msg/DifferentialMeasurement";
}

template<>
struct has_fixed_size<marti_sensor_msgs::msg::DifferentialMeasurement>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<marti_sensor_msgs::msg::DifferentialMeasurement>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<marti_sensor_msgs::msg::DifferentialMeasurement>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MARTI_SENSOR_MSGS__MSG__DETAIL__DIFFERENTIAL_MEASUREMENT__TRAITS_HPP_
